searchNodes=[{"doc":"Type conversion library for Elixir and Erlang.","ref":"Want.html","title":"Want","type":"module"},{"doc":"Cast a value to an atom. Options :exists - If true, only convert to an atom if a matching atom already exists. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.atom(&quot;hello&quot;) iex&gt; Want.atom(1.0) iex&gt; Want.atom({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to atom.&quot;} iex&gt; Want.atom({:a, :b}, default: :c) iex&gt; Want.atom(&quot;10&quot;, exists: true)","ref":"Want.html#atom/1","title":"Want.atom/1","type":"function"},{"doc":"","ref":"Want.html#atom/2","title":"Want.atom/2","type":"function"},{"doc":"","ref":"Want.html#atom!/1","title":"Want.atom!/1","type":"function"},{"doc":"","ref":"Want.html#atom!/2","title":"Want.atom!/2","type":"function"},{"doc":"Check whether the given type name is valid and raise if not.","ref":"Want.html#check_type!/1","title":"Want.check_type!/1","type":"function"},{"doc":"Cast an incoming value to a datetime. Examples iex&gt; Want.datetime(&quot;2020-02-06 18:23:55.850218Z&quot;) iex&gt; Want.datetime({{2020, 02, 06}, {18, 23, 55}}) iex&gt; Want.datetime({{2020, 02, 06}, {18, 23, 55, 123456}})","ref":"Want.html#datetime/1","title":"Want.datetime/1","type":"function"},{"doc":"","ref":"Want.html#datetime/2","title":"Want.datetime/2","type":"function"},{"doc":"","ref":"Want.html#datetime!/1","title":"Want.datetime!/1","type":"function"},{"doc":"","ref":"Want.html#datetime!/2","title":"Want.datetime!/2","type":"function"},{"doc":"Dump a casted input into a more serializable form. Typically used to generate Phoenix query parameters. Options :update - Update the input value using Want.Update protocol before dumping Examples iex&gt; Want.dump({:inserted_at, :desc}) iex&gt; Want.dump({:inserted_at, :desc}, update: :inserted_at) iex&gt; Want.dump({:inserted_at, :desc}, update: :updated_at) iex&gt; Want.dump(&quot;hello&quot;) iex&gt; Want.dump(%{hello: :world, sort: {:inserted_at, :desc}}) iex&gt; Want.dump(%{hello: :world, sort: {:inserted_at, :desc}}, update: [sort: :inserted_at]) iex&gt; Want.dump({:a, :b, :c}) {:error, &quot;Unrecognized dump input {:a, :b, :c}&quot;}","ref":"Want.html#dump/1","title":"Want.dump/1","type":"function"},{"doc":"","ref":"Want.html#dump/2","title":"Want.dump/2","type":"function"},{"doc":"","ref":"Want.html#dump!/1","title":"Want.dump!/1","type":"function"},{"doc":"","ref":"Want.html#dump!/2","title":"Want.dump!/2","type":"function"},{"doc":"Cast an input value to an enum. The input must loosely match one of the allowed values in order for the cast to succeed. Options :valid - List of valid enum values. The input must loosely match one of these. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.enum(&quot;hello&quot;, valid: [:hello, :world]) iex&gt; Want.enum(&quot;hello&quot;, valid: [&quot;hello&quot;, :world]) iex&gt; Want.enum(&quot;foo&quot;, valid: [&quot;hello&quot;, :world], default: :bar)","ref":"Want.html#enum/2","title":"Want.enum/2","type":"function"},{"doc":"","ref":"Want.html#enum!/2","title":"Want.enum!/2","type":"function"},{"doc":"Convert a value to a float. Options :max - Maximum allowable float value. :min - Minimum allowable float value. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.float(1.0) iex&gt; Want.float({:a, :b}, default: 1.0) iex&gt; Want.float(:'5.0', max: 3.0) iex&gt; Want.float(&quot;1.0&quot;, min: 3.0)","ref":"Want.html#float/1","title":"Want.float/1","type":"function"},{"doc":"","ref":"Want.html#float/2","title":"Want.float/2","type":"function"},{"doc":"","ref":"Want.html#float!/1","title":"Want.float!/1","type":"function"},{"doc":"","ref":"Want.html#float!/2","title":"Want.float!/2","type":"function"},{"doc":"Convert a value to an integer. Options :max - Maximum allowable integer value. :min - Minimum allowable integer value. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.integer(1.0) iex&gt; Want.integer({:a, :b}, default: 1) iex&gt; Want.integer(:'5', max: 3) iex&gt; Want.integer(&quot;1&quot;, min: 3)","ref":"Want.html#integer/1","title":"Want.integer/1","type":"function"},{"doc":"","ref":"Want.html#integer/2","title":"Want.integer/2","type":"function"},{"doc":"","ref":"Want.html#integer!/1","title":"Want.integer!/1","type":"function"},{"doc":"","ref":"Want.html#integer!/2","title":"Want.integer!/2","type":"function"},{"doc":"Determine whether the given type name is valid.","ref":"Want.html#is_valid_type?/1","title":"Want.is_valid_type?/1","type":"function"},{"doc":"Cast an incoming keyword list or map to an output keyword list using the provided schema to control conversion rules and validations. Each value in the schema map represents conversion options. Specify a :type field to cast the input value for a given key to that type, defaults to :string. Specific conversion and validation options for each type corresponds to those available for Want.integer/2 , Want.float/2 , Want.string/2 and Want.atom/2 . Keyword lists can be nested by using a new schema map as a value in a parent schema. The field from which a given value is derived can also be modified using the :from option. Examples iex&gt; Want.keywords(%{&quot;id&quot; =&gt; 1}, %{id: [type: :integer]}) iex&gt; Want.keywords(%{&quot;identifier&quot; =&gt; 1}, %{id: [type: :integer, from: :identifier]}) iex&gt; Want.keywords(%{}, %{id: [type: :integer, default: 1]}) iex&gt; Want.keywords(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}) iex&gt; Want.keywords(%{&quot;identifier&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1, from: :identifier]}) iex&gt; Want.keywords(%{&quot;hello&quot; =&gt; &quot;world&quot;, &quot;foo&quot; =&gt; &quot;bar&quot;}, %{hello: [], foo: [type: :atom]}) iex&gt; Want.keywords(%{&quot;hello&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, %{hello: %{foo: [type: :atom]}}) iex&gt; Want.keywords(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}, merge: [id: 2])","ref":"Want.html#keywords/3","title":"Want.keywords/3","type":"function"},{"doc":"","ref":"Want.html#keywords!/3","title":"Want.keywords!/3","type":"function"},{"doc":"Cast an input into a list. By default this function will simply break up the input into list elements, but further casting and validation of elements can be performed by providing an element option. The separator used to split the list defaults to the comma character and this can be controlled using the separator option. Options :separator - Determines the character(s) used to separate list items. Defaults to the comma character. :element - Provides the ability to further control how list elements are cast and validated. Similar to the map and keywords functions, accepts a keyword list with its own :type field and validation options. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.list(&quot;1&quot;) iex&gt; Want.list(&quot;1&quot;, element: [type: :integer]) iex&gt; Want.list(&quot;1,2,3,4&quot;, element: [type: :integer]) iex&gt; Want.list(&quot;1:2:3:4&quot;, separator: &quot;:&quot;, element: [type: :integer]) iex&gt; Want.list(&quot;hello:world&quot;, separator: &quot;:&quot;, element: [type: :enum, valid: [:hello, :world]]) iex&gt; Want.list(&quot;hello:world&quot;, separator: &quot;:&quot;, element: [type: :enum, valid: [:hello]])","ref":"Want.html#list/2","title":"Want.list/2","type":"function"},{"doc":"","ref":"Want.html#list!/2","title":"Want.list!/2","type":"function"},{"doc":"Cast an incoming keyword list or map to an output map using the provided schema to control conversion rules and validations. Each value in the schema map represents conversion options. Specify a :type field to cast the input value for a given key to that type, defaults to :string. Specific conversion and validation options for each type corresponds to those available for Want.integer/2 , Want.float/2 , Want.string/2 and Want.atom/2 . Maps can be nested by using a new schema map as a value in a parent schema. The field from which a given value is derived can also be modified using the :from option. Options :merge - Provide a map matching the given schema that contains default values to be used if the input value does not contain a particular field. Useful when updating a map with new inputs without overwriting all fields. Examples iex&gt; Want.map(%{&quot;id&quot; =&gt; 1}, %{id: [type: :integer]}) {:ok, %{id: 1}} iex&gt; Want.map(%{&quot;identifier&quot; =&gt; 1}, %{id: [type: :integer, from: :identifier]}) {:ok, %{id: 1}} iex&gt; Want.map(%{}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.map(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.map(%{&quot;hello&quot; =&gt; &quot;world&quot;, &quot;foo&quot; =&gt; &quot;bar&quot;}, %{hello: [], foo: [type: :atom]}) {:ok, %{hello: &quot;world&quot;, foo: :bar}} iex&gt; Want.map(%{&quot;hello&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, %{hello: %{foo: [type: :atom]}}) {:ok, %{hello: %{foo: :bar}}} iex&gt; Want.map(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}, merge: %{id: 2}) {:ok, %{id: 2}}","ref":"Want.html#map/3","title":"Want.map/3","type":"function"},{"doc":"","ref":"Want.html#map!/3","title":"Want.map!/3","type":"function"},{"doc":"Cast an input to a sort tuple. Options :fields - List of allowed sort fields. Casting will fail if the input doesn't match any of these. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.sort(&quot;inserted_at:desc&quot;, fields: [:inserted_at, :id, :name]) {:ok, {:inserted_at, :desc}} iex&gt; Want.sort(&quot;updated_at&quot;, fields: [:inserted_at, :id], default: {:id, :asc}) {:ok, {:id, :asc}} iex&gt; Want.sort(&quot;updated_at:asc&quot;, [])","ref":"Want.html#sort/2","title":"Want.sort/2","type":"function"},{"doc":"","ref":"Want.html#sort!/2","title":"Want.sort!/2","type":"function"},{"doc":"Convert a value to a string. Options :max - Maximum allowable string length. :min - Minimum allowable string length. ':decode' - Currently only supports :uri; runs URI.decode on the input value :matches - The resulting string must match the given regex. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.string(1) iex&gt; Want.string({:a, :b}, default: &quot;string&quot;) iex&gt; Want.string(:hello, max: 3) iex&gt; Want.string(&quot;hello%20world&quot;, decode: :uri) iex&gt; Want.string(:a, min: 3) iex&gt; Want.string(:a, matches: ~r/a/)","ref":"Want.html#string/1","title":"Want.string/1","type":"function"},{"doc":"","ref":"Want.html#string/2","title":"Want.string/2","type":"function"},{"doc":"","ref":"Want.html#string!/1","title":"Want.string!/1","type":"function"},{"doc":"","ref":"Want.html#string!/2","title":"Want.string!/2","type":"function"},{"doc":"Return a list of atoms describing the types that Want recognizes.","ref":"Want.html#valid_types/0","title":"Want.valid_types/0","type":"function"},{"doc":"","ref":"Want.html#t:enumerable/0","title":"Want.enumerable/0","type":"type"},{"doc":"","ref":"Want.Any.html","title":"Want.Any","type":"module"},{"doc":"Performs type conversions to atom values.","ref":"Want.Atom.html","title":"Want.Atom","type":"module"},{"doc":"Cast a value to an atom. Options :exists - If true, only convert to an atom if a matching atom already exists. Examples iex&gt; Want.Atom.cast(&quot;hello&quot;) iex&gt; Want.Atom.cast(1.0) iex&gt; Want.Atom.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to atom.&quot;} iex&gt; Want.Atom.cast(&quot;10&quot;, exists: true)","ref":"Want.Atom.html#cast/1","title":"Want.Atom.cast/1","type":"function"},{"doc":"Callback implementation for Want.Type.cast/2 .","ref":"Want.Atom.html#cast/2","title":"Want.Atom.cast/2","type":"function"},{"doc":"","ref":"Want.Atom.html#t:result/0","title":"Want.Atom.result/0","type":"type"},{"doc":"Provides conversions to and from Elixir Date structs.","ref":"Want.Date.html","title":"Want.Date","type":"module"},{"doc":"Cast a value to an date. Options :decode - If set to :uri , executes a URI decode on the input value before casting it. Examples iex&gt; Want.Date.cast(&quot;2022-03-04&quot;) {:ok, %Date{year: 2022, month: 03, day: 04}}","ref":"Want.Date.html#cast/1","title":"Want.Date.cast/1","type":"function"},{"doc":"","ref":"Want.Date.html#cast/2","title":"Want.Date.cast/2","type":"function"},{"doc":"","ref":"Want.Date.html#t:result/0","title":"Want.Date.result/0","type":"type"},{"doc":"Provides conversions to and from Elixir DateTime structs.","ref":"Want.DateTime.html","title":"Want.DateTime","type":"module"},{"doc":"","ref":"Want.DateTime.html#cast/2","title":"Want.DateTime.cast/2","type":"function"},{"doc":"","ref":"Want.DateTime.html#t:result/0","title":"Want.DateTime.result/0","type":"type"},{"doc":"","ref":"Want.DateTime.html#t:t/0","title":"Want.DateTime.t/0","type":"type"},{"doc":"Behaviour for type casting modules.","ref":"Want.Dump.html","title":"Want.Dump","type":"protocol"},{"doc":"Dumps an incoming value to an output type.","ref":"Want.Dump.html#dump/2","title":"Want.Dump.dump/2","type":"function"},{"doc":"All the types that implement this protocol.","ref":"Want.Dump.html#t:t/0","title":"Want.Dump.t/0","type":"type"},{"doc":"Provides type conversions to enumerations.","ref":"Want.Enum.html","title":"Want.Enum","type":"module"},{"doc":"Cast a given value to an enum value. The given options keyword list must include an array of valid enum values under the :valid key, otherwise the function will return an error tuple. Options :valid - List of valid enum values. The input must loosely match one of these. Examples iex&gt; Want.Enum.cast(&quot;hello&quot;, valid: [:hello, :world]) iex&gt; Want.Enum.cast(&quot;hello&quot;, valid: [&quot;hello&quot;, :world])","ref":"Want.Enum.html#cast/2","title":"Want.Enum.cast/2","type":"function"},{"doc":"","ref":"Want.Enum.html#cast/3","title":"Want.Enum.cast/3","type":"function"},{"doc":"","ref":"Want.Enum.html#t:result/0","title":"Want.Enum.result/0","type":"type"},{"doc":"Performs type conversions to float values.","ref":"Want.Float.html","title":"Want.Float","type":"module"},{"doc":"Cast a value to a float. Options :max - Maximum allowable float value. :min - Minimum allowable float value. Examples iex&gt; Want.Float.cast(&quot;1&quot;) iex&gt; Want.Float.cast(1.0) iex&gt; Want.Float.cast(:'1') iex&gt; Want.Float.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to float.&quot;} iex&gt; Want.Float.cast(&quot;10&quot;, max: 3.0) iex&gt; Want.Float.cast(1.0, min: 3.0)","ref":"Want.Float.html#cast/1","title":"Want.Float.cast/1","type":"function"},{"doc":"Callback implementation for Want.Type.cast/2 .","ref":"Want.Float.html#cast/2","title":"Want.Float.cast/2","type":"function"},{"doc":"","ref":"Want.Float.html#t:result/0","title":"Want.Float.result/0","type":"type"},{"doc":"Manages conversions to and from integers.","ref":"Want.Integer.html","title":"Want.Integer","type":"module"},{"doc":"Cast a value to an integer. Options :max - Maximum allowable integer value. :min - Minimum allowable integer value. Examples iex&gt; Want.Integer.cast(&quot;1&quot;) iex&gt; Want.Integer.cast(1.0) iex&gt; Want.Integer.cast(:'1') iex&gt; Want.Integer.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to integer.&quot;} iex&gt; Want.Integer.cast(&quot;10&quot;, max: 3) iex&gt; Want.Integer.cast(1.0, min: 3)","ref":"Want.Integer.html#cast/1","title":"Want.Integer.cast/1","type":"function"},{"doc":"Callback implementation for Want.Type.cast/2 .","ref":"Want.Integer.html#cast/2","title":"Want.Integer.cast/2","type":"function"},{"doc":"","ref":"Want.Integer.html#t:result/0","title":"Want.Integer.result/0","type":"type"},{"doc":"Manages conversions to and from keyword lists.","ref":"Want.Keyword.html","title":"Want.Keyword","type":"module"},{"doc":"Cast an incoming keyword list or map to an output keyword list using the provided schema to control conversion rules and validations. Examples iex&gt; Want.Keyword.cast(%{&quot;id&quot; =&gt; 1}, %{id: [type: :integer]}) iex&gt; Want.Keyword.cast(%{&quot;archived&quot; =&gt; &quot;true&quot;}, %{archived: [type: :boolean, default: false]}) iex&gt; Want.Keyword.cast(%{&quot;archived&quot; =&gt; &quot;false&quot;}, %{archived: [type: :boolean, default: false]}) iex&gt; Want.Keyword.cast(%{}, %{archived: [type: :boolean, default: false]}) iex&gt; Want.Keyword.cast(%{}, %{id: [type: :integer, default: 1]}) iex&gt; Want.Keyword.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}) iex&gt; Want.Keyword.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;, &quot;foo&quot; =&gt; &quot;bar&quot;}, %{hello: [], foo: [type: :atom]}) iex&gt; Want.Keyword.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;}, %{hello: [], foo: [required: true]}) iex&gt; Want.Map.cast(%{&quot;datetime&quot; =&gt; DateTime.from_unix!(0)}, %{datetime: [type: :datetime]}) {:ok, %{datetime: DateTime.from_unix!(0)}} iex&gt; Want.Map.cast(%{&quot;datetime&quot; =&gt; &quot;1970-01-01T00:00:00Z&quot;}, %{datetime: [type: :datetime]}) {:ok, %{datetime: DateTime.from_unix!(0)}} iex&gt; Want.Keyword.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;}, %{hello: [], foo: []}) iex&gt; Want.Keyword.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;}, %{hello: [type: :enum, valid: [:world]]}) iex&gt; Want.Keyword.cast(%{&quot;hello&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, %{hello: %{foo: [type: :atom]}}) iex&gt; Want.Keyword.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}, merge: [id: 2]) iex&gt; Want.Keyword.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :any]}) iex&gt; Want.Keyword.cast(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 100}}}, %{id: [type: :integer, from: {&quot;a&quot;, &quot;b&quot;, &quot;c&quot;}]})","ref":"Want.Keyword.html#cast/2","title":"Want.Keyword.cast/2","type":"function"},{"doc":"","ref":"Want.Keyword.html#cast/3","title":"Want.Keyword.cast/3","type":"function"},{"doc":"","ref":"Want.Keyword.html#t:enumerable/0","title":"Want.Keyword.enumerable/0","type":"type"},{"doc":"","ref":"Want.Keyword.html#t:input/0","title":"Want.Keyword.input/0","type":"type"},{"doc":"","ref":"Want.Keyword.html#t:key/0","title":"Want.Keyword.key/0","type":"type"},{"doc":"","ref":"Want.Keyword.html#t:opts/0","title":"Want.Keyword.opts/0","type":"type"},{"doc":"","ref":"Want.Keyword.html#t:result/0","title":"Want.Keyword.result/0","type":"type"},{"doc":"","ref":"Want.Keyword.html#t:schema/0","title":"Want.Keyword.schema/0","type":"type"},{"doc":"Manages conversions to and from lists.","ref":"Want.List.html","title":"Want.List","type":"module"},{"doc":"Cast an input into a list. By default this function will simply break up the input into list elements, but further casting and validation of elements can be performed by providing an element option. The separator used to split the list defaults to the comma character and this can be controlled using the separator option. Options :separator - Determines the character(s) used to separate list items. Defaults to the comma character. :element - Provides the ability to further control how list elements are cast and validated. Similar to the map and keywords functions, accepts a keyword list with its own :type field and validation options. Examples iex&gt; Want.List.cast(&quot;1&quot;) iex&gt; Want.List.cast(&quot;1&quot;, element: [type: :integer]) iex&gt; Want.List.cast(&quot;1,2,3,4&quot;, element: [type: :integer]) iex&gt; Want.List.cast(&quot;1:2:3:4&quot;, separator: &quot;:&quot;, element: [type: :integer]) iex&gt; Want.List.cast(&quot;hello:world&quot;, separator: &quot;:&quot;, element: [type: :enum, valid: [:hello, :world]]) iex&gt; Want.List.cast(&quot;hello:world&quot;, separator: &quot;:&quot;, element: [type: :enum, valid: [:hello]])","ref":"Want.List.html#cast/1","title":"Want.List.cast/1","type":"function"},{"doc":"Callback implementation for Want.Type.cast/2 .","ref":"Want.List.html#cast/2","title":"Want.List.cast/2","type":"function"},{"doc":"","ref":"Want.List.html#t:element/0","title":"Want.List.element/0","type":"type"},{"doc":"","ref":"Want.List.html#t:result/0","title":"Want.List.result/0","type":"type"},{"doc":"Manages conversions to and from maps.","ref":"Want.Map.html","title":"Want.Map","type":"module"},{"doc":"Cast an incoming keyword list or map to an output map using the provided schema to control conversion rules and validations. Options :merge - Provide a map matching the given schema that contains default values to be used if the input value does not contain a particular field. Useful when updating a map with new inputs without overwriting all fields. Examples iex&gt; Want.Map.cast(%{&quot;id&quot; =&gt; 1}, %{id: [type: :integer]}) {:ok, %{id: 1}} iex&gt; Want.Map.cast(%{}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.Map.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.Map.cast(%{&quot;archived&quot; =&gt; &quot;true&quot;}, %{archived: [type: :boolean, default: false]}) {:ok, %{archived: true}} iex&gt; Want.Map.cast(%{&quot;archived&quot; =&gt; &quot;false&quot;}, %{archived: [type: :boolean, default: false]}) {:ok, %{archived: false}} iex&gt; Want.Map.cast(%{}, %{archived: [type: :boolean, default: false]}) {:ok, %{archived: false}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;, &quot;foo&quot; =&gt; &quot;bar&quot;}, %{hello: [], foo: [type: :atom]}) {:ok, %{hello: &quot;world&quot;, foo: :bar}} iex&gt; Want.Map.cast(%{&quot;date&quot; =&gt; %Date{year: 2022, month: 01, day: 02}}, %{date: [type: :date]}) {:ok, %{date: %Date{year: 2022, month: 01, day: 02}}} iex&gt; Want.Map.cast(%{&quot;date&quot; =&gt; &quot;2022-01-02&quot;}, %{date: [type: :date]}) {:ok, %{date: %Date{year: 2022, month: 01, day: 02}}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;}, %{hello: [], foo: [required: true]}) iex&gt; Want.Map.cast(%{&quot;c&quot; =&gt; &quot;world&quot;}, %{foo: [type: :string, from: [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;]]}) {:ok, %{foo: &quot;world&quot;}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;}, %{hello: [type: :enum, valid: [:world]]}) {:ok, %{hello: :world}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;}, %{hello: [], foo: []}) {:ok, %{hello: &quot;world&quot;}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, %{hello: %{foo: [type: :atom]}}) {:ok, %{hello: %{foo: :bar}}} iex&gt; Want.Map.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}, merge: %{id: 2}) {:ok, %{id: 2}} iex&gt; Want.Map.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :any]}) {:ok, %{id: &quot;bananas&quot;}} iex&gt; Want.Map.cast(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 100}}}, %{id: [type: :integer, from: {&quot;a&quot;, &quot;b&quot;, &quot;c&quot;}]}) {:ok, %{id: 100}}","ref":"Want.Map.html#cast/2","title":"Want.Map.cast/2","type":"function"},{"doc":"","ref":"Want.Map.html#cast/3","title":"Want.Map.cast/3","type":"function"},{"doc":"","ref":"Want.Map.html#t:enumerable/0","title":"Want.Map.enumerable/0","type":"type"},{"doc":"","ref":"Want.Map.html#t:input/0","title":"Want.Map.input/0","type":"type"},{"doc":"","ref":"Want.Map.html#t:key/0","title":"Want.Map.key/0","type":"type"},{"doc":"","ref":"Want.Map.html#t:opts/0","title":"Want.Map.opts/0","type":"type"},{"doc":"","ref":"Want.Map.html#t:result/0","title":"Want.Map.result/0","type":"type"},{"doc":"","ref":"Want.Map.html#t:schema/0","title":"Want.Map.schema/0","type":"type"},{"doc":"Provides macros for declaring an Ecto-like schema definition that can be used to cast incoming data. Most of the macro logic here was adapted from Ecto.Schema .","ref":"Want.Shape.html","title":"Want.Shape","type":"module"},{"doc":"Cast incoming data based on a Shape definition.","ref":"Want.Shape.html#cast/2","title":"Want.Shape.cast/2","type":"function"},{"doc":"Cast incoming data based on a Shape definition. Raises on error.","ref":"Want.Shape.html#cast!/2","title":"Want.Shape.cast!/2","type":"function"},{"doc":"Define a field within a shape.","ref":"Want.Shape.html#field/3","title":"Want.Shape.field/3","type":"macro"},{"doc":"Define a schema. Generates a struct definition for the current module that includes the data needed to correctly cast incoming JSON/map data into that struct, including field sourcing, type conversions, etc.","ref":"Want.Shape.html#shape/1","title":"Want.Shape.shape/1","type":"macro"},{"doc":"Specialized functions for dealing with sort parameters in Phoenix requests.","ref":"Want.Sort.html","title":"Want.Sort","type":"module"},{"doc":"Callback implementation for Want.Type.cast/2 .","ref":"Want.Sort.html#cast/2","title":"Want.Sort.cast/2","type":"function"},{"doc":"","ref":"Want.Sort.html#cast/3","title":"Want.Sort.cast/3","type":"function"},{"doc":"","ref":"Want.Sort.html#t:direction/0","title":"Want.Sort.direction/0","type":"type"},{"doc":"","ref":"Want.Sort.html#t:result/0","title":"Want.Sort.result/0","type":"type"},{"doc":"","ref":"Want.Sort.html#t:sort/0","title":"Want.Sort.sort/0","type":"type"},{"doc":"Manages conversions to and from strings.","ref":"Want.String.html","title":"Want.String","type":"module"},{"doc":"Casts a given value to a string. Options :max - Maximum allowable string length. :min - Minimum allowable string length. ':decode' - Currently only supports :uri; runs URI.decode on the input value :matches - The resulting string must match the given regex. Examples iex&gt; Want.String.cast(1) iex&gt; Want.String.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to string.&quot;} iex&gt; Want.String.cast(:hello, max: 3) iex&gt; Want.String.cast(:a, min: 3) iex&gt; Want.String.cast(&quot;hello%20world&quot;, decode: :uri) iex&gt; Want.String.cast(:a, matches: ~r/a/)","ref":"Want.String.html#cast/1","title":"Want.String.cast/1","type":"function"},{"doc":"Callback implementation for Want.Type.cast/2 .","ref":"Want.String.html#cast/2","title":"Want.String.cast/2","type":"function"},{"doc":"","ref":"Want.String.html#t:result/0","title":"Want.String.result/0","type":"type"},{"doc":"Behaviour for type casting modules.","ref":"Want.Type.html","title":"Want.Type","type":"behaviour"},{"doc":"","ref":"Want.Type.html#c:cast/2","title":"Want.Type.cast/2","type":"callback"},{"doc":"","ref":"Want.Type.html#t:opts/0","title":"Want.Type.opts/0","type":"type"},{"doc":"","ref":"Want.Type.html#t:schema/0","title":"Want.Type.schema/0","type":"type"},{"doc":"Behaviour for type casting modules.","ref":"Want.Update.html","title":"Want.Update","type":"protocol"},{"doc":"Updates an existing value with a new one","ref":"Want.Update.html#update/2","title":"Want.Update.update/2","type":"function"},{"doc":"All the types that implement this protocol.","ref":"Want.Update.html#t:t/0","title":"Want.Update.t/0","type":"type"}]